import { ApiProperty } from '@nestjs/swagger';
import { IsBoolean, IsObject, IsString, ValidateIf } from 'class-validator';

export class CreateReportBookmarkDto {
  @ApiProperty({ name: 'group_name', required: true })
  @IsString()
  group_name: string;

  @ApiProperty({ name: 'unique_name', required: true })
  @IsString()
  unique_name: string;

  @ApiProperty({ name: 'label', required: true })
  @IsString()
  label: string;

  @ApiProperty({ name: 'applied', required: true })
  @IsBoolean()
  applied: boolean;

  @ApiProperty({ name: 'type', required: true })
  @IsBoolean()
  type: 'table_config' | 'filter';

  @ApiProperty({
    name: 'configuration',
    type: Object,
    required: true,
  })
  @IsObject()
  @ValidateIf((body) => body.configuration)
  configuration: any;
}
